## lxd 0.1

=== Makefile ===
.PHONY: default
default:
	go install -v ./...

.PHONY: check
check: default
	cd test && ./main.sh

# dist is primarily for use when packaging; for development we still manage
# dependencies via `go get` explicitly.
# TODO: use git describe for versioning
VERSION=$(shell grep "var Version" shared/flex.go | sed -r -e 's/.*"([0-9\.]*)"/\1/')
ARCHIVE=lxd-$(VERSION).tar

.PHONY: dist
dist:
	rm -Rf lxd-$(VERSION) $(ARCHIVE) $(ARCHIVE).gz
	mkdir -p lxd-$(VERSION)/dist
	GOPATH=$(shell pwd)/lxd-$(VERSION)/dist go get -d -v ./...
	rm -rf $(shell pwd)/lxd-$(VERSION)/dist/src/github.com/lxc/lxd
	ln -s ../../../.. ./lxd-$(VERSION)/dist/src/github.com/lxc/lxd
	git archive --prefix=lxd-$(VERSION)/ --output=$(ARCHIVE) HEAD
	tar -uf $(ARCHIVE) --exclude-vcs lxd-$(VERSION)/
	gzip -9 $(ARCHIVE)
	rm -Rf dist lxd-$(VERSION) $(ARCHIVE)

.PHONY: i18n
i18n:
	xgettext -d lxd -s client.go lxc/*.go -o po/lxd.pot -L c++ -i --keyword=Gettext

=== debian/changelog ===
lxd (0.1-0ubuntu1) vivid; urgency=medium

  * Initial upstream release.

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 13 Feb 2015 16:32:33 -0500

=== debian/control ===
Source: lxd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 3.9.5
Homepage: https://linuxcontainers.org/
Vcs-Git: git://github.com/lxc/lxd-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
Build-Depends: debhelper (>= 9),
               dh-systemd,
               golang-go (>= 1.3~),
               help2man,
               lxc-dev (>= 1.1.0~),
               pkg-config

Package: lxd-client
Architecture: amd64 i386 armhf
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: lxd
Description: Container hypervisor based on LXC - client
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the command line client.

Package: lxd
Architecture: amd64 i386 armhf
Depends: lxc, ${misc:Depends}, ${shlibs:Depends}
Recommends: lxd-client
Description: Container hypervisor based on LXC - daemon
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the LXD daemon.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGDIR=debian/tmp
VERSION=$(shell grep "var Version" $(CURDIR)/shared/flex.go | sed -r -e 's/.*"([0-9\.]*)"/\1/')

export GOPATH := $(CURDIR)/dist/
export PATH := $(PATH):$(GOPATH)/bin/

%:
	dh $@

override_dh_auto_build: ;

override_dh_install:
	go install -v github.com/lxc/lxd/lxc
	go install -v github.com/lxc/lxd/lxd
	mkdir -p $(PKGDIR)/usr/bin $(PKGDIR)/usr/share/
	cp $(GOPATH)/bin/* $(PKGDIR)/usr/bin/

	mkdir -p $(PKGDIR)/usr/share/man/man1/
	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info --version-string=$(VERSION) > $(PKGDIR)/usr/share/man/man1/lxd.1
	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info --version-string=$(VERSION) > $(PKGDIR)/usr/share/man/man1/lxc.1

	dh_install

override_dh_auto_test:
	# cd test && ./main.sh

## lxd 0.4

=== debian/changelog ===
lxd (1:0.4) cosmic; urgency=medium

  * Remove rc.d symlinks (LP: #1797175)

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 10 Oct 2018 12:28:15 -0400

lxd (1:0.3) cosmic; urgency=medium

  * Install the snap on package installation too, not just upgrades
  * Make snapd a Pre-Depends for the case where snapd isn't installed

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 13 Sep 2018 14:28:29 -0400

lxd (1:0.2) cosmic; urgency=medium

  * Make it possible to abort the upgrade when run interactively
  * Introduce transitional packages to make proposed-migration happy

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 13 Sep 2018 10:26:17 -0400

lxd (1:0.1) cosmic; urgency=medium

  * Switch over to the snap (LP: #1788040)
    - Empty the source package
    - Bump epoch to 1
    - Switch package to native
    - Drop lxd-client and lxd-tools packages
  * When installing/upgrading to this package, a preinst script will
    install the LXD snap and transition all data over to it.

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 12 Sep 2018 17:39:23 -0400

lxd (3.0.2-0ubuntu3) cosmic; urgency=medium

  * Add missing test dependency (socat)

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 22 Aug 2018 01:50:48 -0400

lxd (3.0.2-0ubuntu2) cosmic; urgency=medium

  * Disable static analysis tests in autopkgtest

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 22 Aug 2018 00:16:47 -0400

lxd (3.0.2-0ubuntu1) cosmic; urgency=medium

  * New upstream bugfix release (LP: #1788280):
    - container: containerCreateAsCopy() update pool
    - forkmount: ignore ENOENT and EINVAL on umount2()
    - nsexec: simplify attach_userns()
    - Fall back to alternate way of detecting minor version of NVIDIA driver
    - lxd/maas: Make error more readable
    - lxd-p2c: Send rsync output to stderr
    - lxd/migration: Don't pass -vP to a hidden rsync
    - lxc: Properly handle --target in copy and move
    - memory: fix format string
    - lxc/move: Support config and profile overrides
    - i18n: Update translation templates
    - exec: fix format string
    - images: fix format string
    - migrate: remove debug residuals
    - lvm: fix format string
    - db: fix format string
    - nsexec: prevent fd leak
    - Fix the storage_pool_id filter for the WHERE clause of StoragePoolsConfig
    - Fix lints
    - Extract cmdInit.ApplyConfig into a separate initApplyConfig function
    - Split initApplyConfig into initDataNodeApply and initDataClusterApply
    - Fix broken alternate TLS server cert in integration tests
    - lxd/containers: Don't update MAAS for snapshots
    - lxd/maas: Allow starting with MAAS offline
    - Enable tcp KeepAlive
    - lxd/cluster: Improve error on bad target
    - reader: Handle EINTR
    - allow uidmaps to be parsed from alternate roots
    - lxd/storage/zfs: Improve defaults
    - test: Fix static analysis
    - Allow identity mappings for unprivileged containers
    - container: adapt allowedUnprivilegedOnlyMap()
    - shared: Dereference directory symlinks
    - lxd,shared: Move parseNumberFromFile to shared
    - lxc/network: Add --format option to list
    - lxd/db: Don't hang after bad request
    - lxd/apparmor: Allow ro bind-mounts and remounts
    - idmap: support skipping directories
    - lxd: Properly set containerArgs in all cases
    - lxd/storage: Fix PATCH on storage pools
    - container: use lxcSetConfigItem() for lxc.log.file
    - lxc/cluster: Remove bad alias
    - lxd/storage: Fix volume creation API
    - tests: Add alternative TCP port finder
    - doc: Document hostname requirements
    - networks: Support stateful DHCPv6 with prefixes longer than /64
    - lxd/networks: Skip DHCP mangle if firewall off
    - network: do not print writer struct on error
    - lxd/patches: Force a one-time config re-gen
    - storage pools: move structs
    - storage volumes: move structs
    - images: move structs
    - client: Export OperationWait
    - lxd/cluster: Only restart local containers
    - images: consistently name command structs
    - cluster: move structs
    - api 1.0: move struct
    - api internal: move structs
    - certificates: move structs
    - events: move structs
    - operations: move structs
    - profiles: move structs
    - resources: move structs
    - container logs: move structs
    - container post: move structs
    - lxd/storage/btrfs: Fix recursive snapshots
    - lxd/cluster: Fix attaching CEPH custom volumes
    - lxd/storage: Fix double quoting
    - Reduce the frequency of raft snapshots
    - lxd/storage/ceph: Don't keep snapshots mounted
    - util linux: add abstract unix socket helpers
    - proxy: Rework to match master
    - lxd: Cleanup logging
    - lxd: Improve error messages
    - proxy: Properly handle relay errors
    - lxd/certificates: Log password failures
    - proxy: handle full socket buffer
    - gpu: special case passing all GPUs
    - gpu: don't fail during parse
    - gpu: handle cards among Nvidia devices
    - gpu: fix Nvidia minor index parsing
    - lxd/containers: Fix removing NVIDIA containers
    - doc: Add links to REST API
    - doc: Fix storage volume examples
    - lxd/operations: Forward to right cluster node
    - lxc/{copy,move}: Allow overriding device config
    - i18n: Update translations
    - tests: Perform a lazy umount in case of errors
    - lxd/networks: Improve dnsmasq leases cleanup
    - migration: fix cross version migrations
    - doc: Note that default profile cannot be deleted/renamed
    - lxc/profile: Fix "get" command
    - lxd: Prevent renaming/deletion of the default profile
    - test: Test default profile renaming/deletion
    - Fix "neighbour: ndisc_cache: neighbor table overflow"
    - lxd: Fix StoragePoolVolumesGetNames
    - lxd/apparmor: Fix typo in nesting profile
    - lxd/patches: Make config re-gen fault tollerant
    - fix links in api-extension
    - lxd/db: Fix handling of NetworkConfigClear
    - lxd/networks: Fix PATCH operations


## lxd 0.4.2

=== debian/changelog ===
lxd (1:0.4.2) cosmic; urgency=medium

  [ Balint Reczey ]
  * Fix error message on missing snap. (LP: #1821924)

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 11 Apr 2019 10:37:34 -0400

lxd (1:0.4.1) cosmic; urgency=medium

  [ Balint Reczey ]
  * Allow skipping snap installation when LXD was never used
    (LP: #1821924)

  [ Stéphane Graber ]
  * Tweak debconf messages a bit.

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 05 Apr 2019 12:28:54 -0400

## lxd 0.5

=== Makefile ===
--- 
+++ 
@@ -1,16 +1,30 @@
-.PHONY: default
-default:
-	go install -v ./...
-
-.PHONY: check
-check: default
-	cd test && ./main.sh
+DOMAIN=lxd
+POFILES=$(wildcard po/*.po)
+MOFILES=$(patsubst %.po,%.mo,$(POFILES))
+LINGUAS=$(basename $(POFILES))
+POTFILE=po/$(DOMAIN).pot
 
 # dist is primarily for use when packaging; for development we still manage
 # dependencies via `go get` explicitly.
 # TODO: use git describe for versioning
 VERSION=$(shell grep "var Version" shared/flex.go | sed -r -e 's/.*"([0-9\.]*)"/\1/')
 ARCHIVE=lxd-$(VERSION).tar
+
+.PHONY: default
+default:
+	go install -v ./...
+
+# This only needs to be done when migrate.proto is actually changed; since we
+# commit the .pb.go in the tree and it's not expected to change very often,
+# it's not a default build step.
+.PHONY: protobuf
+protobuf:
+	protoc --go_out=. ./lxd/migration/migrate.proto
+
+.PHONY: check
+check: default
+	go test ./...
+	cd test && ./main.sh
 
 .PHONY: dist
 dist:
@@ -24,6 +38,21 @@
 	gzip -9 $(ARCHIVE)
 	rm -Rf dist lxd-$(VERSION) $(ARCHIVE)
 
-.PHONY: i18n
-i18n:
-	xgettext -d lxd -s client.go lxc/*.go -o po/lxd.pot -L c++ -i --keyword=Gettext
+.PHONY: i18n update-po update-pot build-mo
+i18n: update-pot
+
+po/%.mo: po/%.po
+	msgfmt --statistics -o $@ $<
+
+po/%.po: po/$(DOMAIN).pot
+	msgmerge -U po/$*.po po/$(DOMAIN).pot
+
+update-po:
+	-for lang in $(LINGUAS); do\
+	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
+	done
+
+update-pot:
+	xgettext -d $(DOMAIN) -s client.go lxc/*.go -o po/$(DOMAIN).pot -L vala -i --keyword=Gettext
+
+build-mo: $(MOFILES)

=== dist/src/code.google.com/p/goprotobuf/protoc-gen-go/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2010 The Go Authors.  All rights reserved.
# http://code.google.com/p/goprotobuf/
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

include $(GOROOT)/src/Make.cmd

test:
	cd testdata && make test

=== dist/src/code.google.com/p/goprotobuf/protoc-gen-go/descriptor/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2010 The Go Authors.  All rights reserved.
# http://code.google.com/p/goprotobuf/
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Not stored here, but descriptor.proto is in http://code.google.com/p/protobuf
# at protobuf-2.5.0/src/google/protobuf/descriptor.proto
regenerate:
	echo WARNING! THIS RULE IS PROBABLY NOT RIGHT FOR YOUR INSTALLATION
	cd $(HOME)/src/protobuf-2.5.0/src && \
	protoc --go_out=. ./google/protobuf/descriptor.proto && \
	sed -i 's,^package google_protobuf,package descriptor,' google/protobuf/descriptor.pb.go && \
	cp ./google/protobuf/descriptor.pb.go $(GOPATH)/src/code.google.com/p/goprotobuf/protoc-gen-go/descriptor/descriptor.pb.go

restore:
	cp descriptor.pb.golden descriptor.pb.go

preserve:
	cp descriptor.pb.go descriptor.pb.golden

=== debian/control ===
--- 
+++ 
@@ -8,13 +8,14 @@
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
 Build-Depends: debhelper (>= 9),
                dh-systemd,
-               golang-go (>= 1.3~),
+               golang-go,
                help2man,
                lxc-dev (>= 1.1.0~),
-               pkg-config
+               pkg-config,
+               protobuf-compiler
 
 Package: lxd-client
-Architecture: amd64 i386 armhf
+Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: lxd
 Description: Container hypervisor based on LXC - client
@@ -24,9 +25,18 @@
  This package contains the command line client.
 
 Package: lxd
-Architecture: amd64 i386 armhf
-Depends: lxc, ${misc:Depends}, ${shlibs:Depends}
+Architecture: any
+Depends: acl,
+         adduser,
+         gnupg,
+         lxc,
+         python3,
+         rsync,
+         xz-utils,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Recommends: lxd-client
+Suggests: criu
 Description: Container hypervisor based on LXC - daemon
  LXD offers a REST API to remotely manage containers over the network,
  using an image based workflow and with support for live migration.

## lxd 0.6

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGDIR=debian/tmp
VERSION=$(shell grep "var Version" $(CURDIR)/shared/flex.go | sed -r -e 's/.*"([0-9\.]*)"/\1/')

export GOPATH := $(CURDIR)/dist/
export PATH := $(PATH):$(GOPATH)/bin/

%:
	dh $@

override_dh_auto_build: ;

override_dh_install:
	go install -v -x github.com/lxc/lxd/lxc
	go install -v -x github.com/lxc/lxd/lxd
	mkdir -p $(PKGDIR)/usr/bin $(PKGDIR)/usr/share/
	cp $(GOPATH)/bin/* $(PKGDIR)/usr/bin/
	cp scripts/lxd-images $(PKGDIR)/usr/bin/

	mkdir -p $(PKGDIR)/usr/share/man/man1/
	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
	help2man $(PKGDIR)/usr/bin/lxd-images -n "The container hypervisor - image importer" --version-string=$(VERSION) --no-info > $(PKGDIR)/usr/share/man/man1/lxd-images.1
	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1

	dh_install

override_dh_auto_test:
	# cd test && ./main.sh

## lxd 0.7

=== debian/changelog ===
lxd (1:0.7) disco; urgency=medium

  [ Balint Reczey ]
  * Fix error message on missing snap. (LP: #1821924)

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 11 Apr 2019 10:35:29 -0400

lxd (1:0.6) disco; urgency=medium

  * Tweak debconf messages a bit.

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 05 Apr 2019 18:02:01 -0400

lxd (1:0.5) disco; urgency=medium

  [ Balint Reczey ]
  * Allow skipping snap installation when LXD was never used
    (LP: #1821924)

  [ Stéphane Graber ]
  * Bump fallback Ubuntu release to 19.04

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 05 Apr 2019 12:09:25 -0400

## lxd 0.8

=== debian/changelog ===
lxd (1:0.8) focal; urgency=medium

  * Update for the LXD 4.0 track.

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 24 Mar 2020 13:44:45 -0400

## lxd 0.9

=== debian/changelog ===
lxd (1:0.9) focal; urgency=medium

  * Detect and handle systems that are unable to run snapd. (LP: #1862550)

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 17 Apr 2020 16:01:48 -0400

=== debian/control ===
Source: lxd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 4.2.1
Homepage: https://linuxcontainers.org/
Vcs-Git: https://github.com/lxc/lxd-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
Build-Depends: debhelper (>= 11)

Package: lxd
Architecture: all
Depends: ${misc:Depends}
Pre-Depends: debconf, snapd
Breaks: lxd-client (<< 1:0.0~), lxd-tools (<< 1:0.0~)
Replaces: lxd-client (<< 1:0.0~), lxd-tools (<< 1:0.0~)
Section: oldlibs
Description: Transitional package - lxd -> snap (lxd)
 This is a transitional dummy package. It can safely be removed.
 .
 lxd is now replaced by the LXD snap.

Package: lxd-client
Architecture: all
Depends: lxd (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package - lxd-client -> LXD snap
 This is a transitional dummy package. It can safely be removed.
 .
 lxd-client is now replaced by the LXD snap.

Package: lxd-tools
Architecture: all
Depends: lxd (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package - lxc-tools -> LXD snap
 This is a transitional dummy package. It can safely be removed.
 .
 lxd-tools is no longer available in the Ubuntu archive.

## lxd 0.10

=== debian/control ===
Source: lxd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 3.9.5
Homepage: https://linuxcontainers.org/
Vcs-Git: git://github.com/lxc/lxd-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
Build-Depends: debhelper (>= 9),
               dh-systemd,
               golang-go,
               help2man,
               lxc-dev (>= 1.1.0~),
               pkg-config,
               protobuf-compiler

Package: lxd-client
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: lxd
Description: Container hypervisor based on LXC - client
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the command line client.

Package: lxd
Architecture: any
Depends: acl,
         adduser,
         gnupg,
         lxc,
         netcat-openbsd,
         python3,
         rsync,
         xz-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: lxd-client
Suggests: criu
Description: Container hypervisor based on LXC - daemon
 LXD offers a REST API to remotely manage containers over the network,
 using an image based workflow and with support for live migration.
 .
 This package contains the LXD daemon.

=== debian/rules ===
--- 
+++ 
@@ -29,5 +29,9 @@
 
 	dh_install
 
+override_dh_installinit:
+	dh_installinit
+	dh_systemd_enable -plxd --name=lxd
+
 override_dh_auto_test:
 	# cd test && ./main.sh

## lxd 0.12

=== Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 	gzip -9 $(ARCHIVE)
 	rm -Rf dist lxd-$(VERSION) $(ARCHIVE)
 
-.PHONY: i18n update-po update-pot build-mo
+.PHONY: i18n update-po update-pot build-mo static-analysis
 i18n: update-pot
 
 po/%.mo: po/%.po
@@ -56,3 +56,6 @@
 	xgettext -d $(DOMAIN) -s client.go lxc/*.go -o po/$(DOMAIN).pot -L vala -i --keyword=Gettext
 
 build-mo: $(MOFILES)
+
+static-analysis:
+	/bin/bash -x -c ". test/static_analysis.sh; static_analysis"

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 export PATH := $(PATH):$(GOPATH)/bin/
 
 %:
-	dh $@
+	dh $@ --with systemd
 
 override_dh_auto_build: ;
 
@@ -31,7 +31,7 @@
 
 override_dh_installinit:
 	dh_installinit
-	dh_systemd_enable -plxd --name=lxd
+	#dh_systemd_enable -plxd --name=lxd
 
 override_dh_auto_test:
 	# cd test && ./main.sh

## lxd 0.14

=== Makefile ===
--- 
+++ 
@@ -12,6 +12,7 @@
 
 .PHONY: default
 default:
+	go get -v -d ./...
 	go install -v ./...
 
 # This only needs to be done when migrate.proto is actually changed; since we
@@ -25,6 +26,9 @@
 check: default
 	go test ./...
 	cd test && ./main.sh
+
+gccgo:
+	go build -compiler gccgo ./...
 
 .PHONY: dist
 dist:

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: https://linuxcontainers.org/
 Vcs-Git: git://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu

## lxd 0.15

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,11 @@
 default:
 	go get -v -d ./...
 	go install -v ./...
+
+.PHONY: client
+client:
+	go get -v -d ./...
+	go install -v ./lxc
 
 # This only needs to be done when migrate.proto is actually changed; since we
 # commit the .pb.go in the tree and it's not expected to change very often,

## lxd 0.16

=== Makefile ===
--- 
+++ 
@@ -12,12 +12,12 @@
 
 .PHONY: default
 default:
-	go get -v -d ./...
+	go get -t -v -d ./... || true
 	go install -v ./...
 
 .PHONY: client
 client:
-	go get -v -d ./...
+	go get -t -v -d ./...
 	go install -v ./lxc
 
 # This only needs to be done when migrate.proto is actually changed; since we

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,8 @@
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
 Build-Depends: debhelper (>= 9),
                dh-systemd,
-               golang-go,
+               golang-go [i386 amd64 armhf arm64],
+               gccgo [powerpc ppc64el],
                help2man,
                lxc-dev (>= 1.1.0~),
                pkg-config,

## lxd 0.17

=== Makefile ===
--- 
+++ 
@@ -12,13 +12,17 @@
 
 .PHONY: default
 default:
-	go get -t -v -d ./... || true
+	-go get -t -v -d ./...
+	-go get -t -v -d ./...
 	go install -v ./...
+	@echo "LXD built succesfuly"
 
 .PHONY: client
 client:
-	go get -t -v -d ./...
+	-go get -t -v -d ./...
+	-go get -t -v -d ./...
 	go install -v ./lxc
+	@echo "LXD client built succesfuly"
 
 # This only needs to be done when migrate.proto is actually changed; since we
 # commit the .pb.go in the tree and it's not expected to change very often,
@@ -34,12 +38,14 @@
 
 gccgo:
 	go build -compiler gccgo ./...
+	@echo "LXD built succesfuly with gccgo"
 
 .PHONY: dist
 dist:
 	rm -Rf lxd-$(VERSION) $(ARCHIVE) $(ARCHIVE).gz
 	mkdir -p lxd-$(VERSION)/dist
-	GOPATH=$(shell pwd)/lxd-$(VERSION)/dist go get -d -v ./...
+	-GOPATH=$(shell pwd)/lxd-$(VERSION)/dist go get -t -v -d ./...
+	GOPATH=$(shell pwd)/lxd-$(VERSION)/dist go get -t -v -d ./...
 	rm -rf $(shell pwd)/lxd-$(VERSION)/dist/src/github.com/lxc/lxd
 	ln -s ../../../.. ./lxd-$(VERSION)/dist/src/github.com/lxc/lxd
 	git archive --prefix=lxd-$(VERSION)/ --output=$(ARCHIVE) HEAD
@@ -68,3 +74,6 @@
 
 static-analysis:
 	/bin/bash -x -c ". test/static_analysis.sh; static_analysis"
+
+tags:
+	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags

=== debian/control ===
--- 
+++ 
@@ -8,8 +8,8 @@
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
 Build-Depends: debhelper (>= 9),
                dh-systemd,
+               gccgo [powerpc ppc64el],
                golang-go [i386 amd64 armhf arm64],
-               gccgo [powerpc ppc64el],
                help2man,
                lxc-dev (>= 1.1.0~),
                pkg-config,
@@ -38,9 +38,19 @@
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: lxd-client
-Suggests: criu
+Suggests: criu, lxd-tools
 Description: Container hypervisor based on LXC - daemon
  LXD offers a REST API to remotely manage containers over the network,
  using an image based workflow and with support for live migration.
  .
  This package contains the LXD daemon.
+
+Package: lxd-tools
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: Container hypervisor based on LXC - extra tools
+ LXD offers a REST API to remotely manage containers over the network,
+ using an image based workflow and with support for live migration.
+ .
+ This package contains extra tools provided with LXD.
+  - fuidshift - A tool to map/unmap filesystem uids/gids

## lxd 0.18

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 # it's not a default build step.
 .PHONY: protobuf
 protobuf:
-	protoc --go_out=. ./lxd/migration/migrate.proto
+	protoc --go_out=. ./lxd/migrate.proto
 
 .PHONY: check
 check: default
@@ -65,10 +65,13 @@
 update-po:
 	-for lang in $(LINGUAS); do\
 	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
+	    rm -f $$lang.po~; \
 	done
 
 update-pot:
-	xgettext -d $(DOMAIN) -s client.go lxc/*.go -o po/$(DOMAIN).pot -L vala -i --keyword=Gettext
+	go get -v -x launchpad.net/~snappy-dev/snappy/snappy/i18n/xgettext-go/
+	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=gettext.Gettext --keyword-plural=gettext.NGettext *.go shared/*.go lxc/*.go lxd/*.go
+
 
 build-mo: $(MOFILES)

=== dist/src/github.com/dustinkirkland/golang-petname/Makefile ===
GO_BUILD=go build
GO_INSTALL=go install
GO_TEST=go test
GO_CLEAN=go clean

all: petname

petname: petname.go cmd/petname/main.go
	$(GO_BUILD)
	GOPATH=$(shell pwd) $(GO_BUILD) -o golang-petname cmd/petname/main.go

test: petname.go petname_test.go
	GOPATH=$(shell pwd) $(GO_TEST)

clean:
	$(RM) -f golang-petname

.PHONY: all clean test

=== dist/src/github.com/golang/protobuf/protoc-gen-go/descriptor/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2010 The Go Authors.  All rights reserved.
# https://github.com/golang/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Not stored here, but descriptor.proto is in https://github.com/google/protobuf/
# at src/google/protobuf/descriptor.proto
regenerate:
	echo WARNING! THIS RULE IS PROBABLY NOT RIGHT FOR YOUR INSTALLATION
	protoc --go_out=. -I$(HOME)/src/protobuf/src $(HOME)/src/protobuf/src/google/protobuf/descriptor.proto && \
		sed 's,^package google_protobuf,package descriptor,' google/protobuf/descriptor.pb.go > \
		$(GOPATH)/src/github.com/golang/protobuf/protoc-gen-go/descriptor/descriptor.pb.go && \
		rm -f google/protobuf/descriptor.pb.go

restore:
	cp descriptor.pb.golden descriptor.pb.go

preserve:
	cp descriptor.pb.go descriptor.pb.golden

=== dist/src/github.com/golang/protobuf/protoc-gen-go/testdata/Makefile ===
# Go support for Protocol Buffers - Google's data interchange format
#
# Copyright 2010 The Go Authors.  All rights reserved.
# https://github.com/golang/protobuf
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

all:
	@echo run make test

include ../../Make.protobuf

test:	golden testbuild

#test:	golden testbuild extension_test
#	./extension_test
#	@echo PASS

golden:
	make -B my_test/test.pb.go
	diff -w my_test/test.pb.go my_test/test.pb.go.golden

nuke:	clean

testbuild:	regenerate
	go test

regenerate:
	# Invoke protoc once to generate three independent .pb.go files in the same package.
	protoc --go_out=. multi/multi{1,2,3}.proto

#extension_test:	extension_test.$O
#	$(LD) -L. -o $@ $<

#multi.a: multi3.pb.$O multi2.pb.$O multi1.pb.$O
#	rm -f multi.a
#	$(QUOTED_GOBIN)/gopack grc $@ $<

#test.pb.go:	imp.pb.go
#multi1.pb.go:	multi2.pb.go multi3.pb.go
#main.$O: imp.pb.$O test.pb.$O multi.a
#extension_test.$O: extension_base.pb.$O extension_extra.pb.$O extension_user.pb.$O

=== debian/rules ===
--- 
+++ 
@@ -16,16 +16,21 @@
 override_dh_auto_build: ;
 
 override_dh_install:
+	go install -v -x github.com/lxc/lxd/fuidshift
 	go install -v -x github.com/lxc/lxd/lxc
 	go install -v -x github.com/lxc/lxd/lxd
-	mkdir -p $(PKGDIR)/usr/bin $(PKGDIR)/usr/share/
+	go install -v -x github.com/lxc/lxd/lxd-bridge/lxd-bridge-proxy
+
+	mkdir -p $(PKGDIR)/usr/bin $(PKGDIR)/usr/share/ $(PKGDIR)/usr/lib/lxd
 	cp $(GOPATH)/bin/* $(PKGDIR)/usr/bin/
 	cp scripts/lxd-images $(PKGDIR)/usr/bin/
+	cp lxd-bridge/lxd-bridge $(PKGDIR)/usr/lib/lxd/
 
 	mkdir -p $(PKGDIR)/usr/share/man/man1/
+	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
+	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
 	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
 	help2man $(PKGDIR)/usr/bin/lxd-images -n "The container hypervisor - image importer" --version-string=$(VERSION) --no-info > $(PKGDIR)/usr/share/man/man1/lxd-images.1
-	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
 
 	dh_install

## lxd 0.19

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
                lxc-dev (>= 1.1.0~),
                pkg-config,
                protobuf-compiler
+XS-Testsuite: autopkgtest
 
 Package: lxd-client
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -36,7 +36,7 @@
 
 override_dh_installinit:
 	dh_installinit
-	#dh_systemd_enable -plxd --name=lxd
+	dh_systemd_enable -plxd --name=lxd-startup
 
 override_dh_auto_test:
-	# cd test && ./main.sh
+	echo "The testsuite requires privileges and so is run through autopkgtest"

## lxd 0.20

=== Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 
 .PHONY: check
 check: default
-	go test ./...
+	go test -v ./...
 	cd test && ./main.sh
 
 gccgo:

=== debian/rules ===
--- 
+++ 
@@ -16,22 +16,31 @@
 override_dh_auto_build: ;
 
 override_dh_install:
+	# Build everything
 	go install -v -x github.com/lxc/lxd/fuidshift
 	go install -v -x github.com/lxc/lxd/lxc
 	go install -v -x github.com/lxc/lxd/lxd
 	go install -v -x github.com/lxc/lxd/lxd-bridge/lxd-bridge-proxy
 
+	# Install the various binaries
 	mkdir -p $(PKGDIR)/usr/bin $(PKGDIR)/usr/share/ $(PKGDIR)/usr/lib/lxd
 	cp $(GOPATH)/bin/* $(PKGDIR)/usr/bin/
 	cp scripts/lxd-images $(PKGDIR)/usr/bin/
 	cp lxd-bridge/lxd-bridge $(PKGDIR)/usr/lib/lxd/
 
+	# Install the manpages
 	mkdir -p $(PKGDIR)/usr/share/man/man1/
 	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
 	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
 	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
 	help2man $(PKGDIR)/usr/bin/lxd-images -n "The container hypervisor - image importer" --version-string=$(VERSION) --no-info > $(PKGDIR)/usr/share/man/man1/lxd-images.1
 
+	# Install cron job
+	mkdir -p ${PKGDIR}/etc/cron.hourly/
+	cp debian/lxd.cron ${PKGDIR}/etc/cron.hourly/
+	chmod 755 ${PKGDIR}/etc/cron.hourly/
+
+	# Trigger normal dh_install
 	dh_install
 
 override_dh_installinit:

=== debian/tests/control ===
Tests: exercise
Depends: acl,
         busybox-static,
         curl,
         gccgo [powerpc ppc64el],
         golang-go [i386 amd64 armhf arm64],
         jq,
         git,
         gettext,
         make,
         sqlite3,
         uuid-runtime,
         @
Restrictions: needs-root allow-stderr

## lxd 0.21

=== debian/changelog ===
lxd (0.21-0ubuntu3~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty (LP: #1508720)
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.

 -- Stéphane Graber <stgraber@ubuntu.com>  Sun, 01 Nov 2015 11:35:14 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGDIR=debian/tmp
VERSION=$(shell grep "var Version" $(CURDIR)/shared/flex.go | sed -r -e 's/.*"([0-9\.]*)"/\1/')

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
export DH_GOPKG := github.com/lxc/lxd
export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)

%:
	dh $@ --with systemd --buildsystem=golang --with=golang

# Ugly workaround for bundled dependencies
override_dh_auto_build:
	mv ${GOPATH}/src/github.com/lxc/lxd ${GOPATH}/lxd.tmp
	rm -Rf ${GOPATH}/src
	cp -R dist/src ${GOPATH}
	rm ${GOPATH}/src/github.com/lxc/lxd
	mv ${GOPATH}/lxd.tmp ${GOPATH}/src/github.com/lxc/lxd

	go install -v github.com/lxc/lxd/lxc
	go install -v github.com/lxc/lxd/lxd
	go install -v github.com/lxc/lxd/fuidshift
	go install -v github.com/lxc/lxd/lxd-bridge/lxd-bridge-proxy

override_dh_install:
	# Install the manpages
	mkdir -p $(PKGDIR)/usr/share/man/man1/
	help2man $(PKGDIR)/usr/bin/fuidshift -n "uid/gid shifter" --no-info > $(PKGDIR)/usr/share/man/man1/fuidshift.1
	help2man $(PKGDIR)/usr/bin/lxc -n "The container hypervisor - client" --no-info > $(PKGDIR)/usr/share/man/man1/lxc.1
	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
	help2man scripts/lxd-images -n "The container hypervisor - image importer" --version-string=$(VERSION) --no-info > $(PKGDIR)/usr/share/man/man1/lxd-images.1

	# Trigger normal dh_install
	dh_install

override_dh_installinit:
	dh_installinit
	dh_systemd_enable -plxd --name=lxd-startup

override_dh_auto_test:
	echo "The testsuite requires privileges and so is run through autopkgtest"

=== debian/tests/control ===
--- 
+++ 
@@ -8,6 +8,9 @@
          git,
          gettext,
          make,
+         pep8,
+         pyflakes,
+         shellcheck,
          sqlite3,
          uuid-runtime,
          @

## lxd 0.22

=== debian/changelog ===
lxd (0.22-0ubuntu2~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty (LP: #1515693, LP: #1515689)
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 12 Nov 2015 11:41:29 -0500

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,10 @@
 Vcs-Git: git://github.com/lxc/lxd-pkg-ubuntu
 Vcs-Browser: https://github.com/lxc/lxd-pkg-ubuntu
 Build-Depends: debhelper (>= 9),
+               dh-golang,
                dh-systemd,
                gccgo [powerpc ppc64el],
-               golang-go [i386 amd64 armhf arm64],
+               golang-go (>= 2:1.3.3-1ubuntu4~) [i386 amd64 armhf arm64],
                help2man,
                lxc-dev (>= 1.1.0~),
                pkg-config,
@@ -17,8 +18,9 @@
 XS-Testsuite: autopkgtest
 
 Package: lxd-client
-Architecture: any
+Architecture: i386 amd64 armhf
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Built-Using: ${misc:Built-Using}
 Suggests: lxd
 Description: Container hypervisor based on LXC - client
  LXD offers a REST API to remotely manage containers over the network,
@@ -27,17 +29,18 @@
  This package contains the command line client.
 
 Package: lxd
-Architecture: any
+Architecture: i386 amd64 armhf
 Depends: acl,
          adduser,
          gnupg,
-         lxc,
+         lxc (>= 1.1.4-0ubuntu1.1~),
          netcat-openbsd,
          python3,
          rsync,
          xz-utils,
          ${misc:Depends},
          ${shlibs:Depends}
+Built-Using: ${misc:Built-Using}
 Recommends: lxd-client
 Suggests: criu, lxd-tools
 Description: Container hypervisor based on LXC - daemon
@@ -47,8 +50,9 @@
  This package contains the LXD daemon.
 
 Package: lxd-tools
-Architecture: any
+Architecture: i386 amd64 armhf
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Built-Using: ${misc:Built-Using}
 Description: Container hypervisor based on LXC - extra tools
  LXD offers a REST API to remotely manage containers over the network,
  using an image based workflow and with support for live migration.

## lxd 0.26

=== debian/changelog ===
lxd (0.26-0ubuntu2~ubuntu14.04.1) trusty-backports; urgency=medium

  * Backport to trusty (LP: #1528395)
  * Arch-restrict all binaries to i386 amd64 armhf.
    The other architectures require a recent gccgo5 and golang 1.5 to build.
  * Add a versioned build-dependency on trusty-backports' golang.
  * Add a versioned depends for lxd on trusty-backports' lxc.
  * Turn bundled dependencies back on.

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 07 Jan 2016 11:48:27 -0500

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                dh-golang,
                dh-systemd,
                gccgo [powerpc ppc64el],
-               golang-go (>= 2:1.3.3-1ubuntu4~) [i386 amd64 armhf arm64],
+               golang-go (>= 2:1.3.3-1ubuntu4~) [i386 amd64 armhf],
                help2man,
                lxc-dev (>= 1.1.0~),
                pkg-config,
@@ -59,3 +59,12 @@
  .
  This package contains extra tools provided with LXD.
   - fuidshift - A tool to map/unmap filesystem uids/gids
+
+Package: golang-github-lxc-lxd-dev
+Architecture: all
+Depends: golang-go, lxc-dev, pkg-config, ${misc:Depends}, ${shlibs:Depends}
+Description: Container hypervisor based on LXC - go source
+ LXD offers a REST API to remotely manage containers over the network,
+ using an image based workflow and with support for live migration.
+ .
+ This package contains the source tree of the lxd project.

=== debian/rules ===
--- 
+++ 
@@ -10,17 +10,115 @@
 # temporary build path (see http://golang.org/doc/code.html#GOPATH)
 export DH_GOPKG := github.com/lxc/lxd
 export GOPATH := $(CURDIR)/obj-$(DEB_BUILD_GNU_TYPE)
+export USE_EMBEDDED := true
 
 %:
 	dh $@ --with systemd --buildsystem=golang --with=golang
 
 # Ugly workaround for bundled dependencies
 override_dh_auto_build:
+	# Get a clean GOPATH
 	mv ${GOPATH}/src/github.com/lxc/lxd ${GOPATH}/lxd.tmp
 	rm -Rf ${GOPATH}/src
+
+ifeq ($(USE_EMBEDDED), true)
 	cp -R dist/src ${GOPATH}
 	rm ${GOPATH}/src/github.com/lxc/lxd
+endif
+
+	# Setup the build environment
+	mkdir -p ${GOPATH}/src/github.com/lxc/
 	mv ${GOPATH}/lxd.tmp ${GOPATH}/src/github.com/lxc/lxd
+
+ifeq ($(USE_EMBEDDED), false)
+	# Packaged dependencies
+	## gosexy/gettext-go
+#	mkdir -p ${GOPATH}/src/github.com/gosexy/
+#	ln -s /usr/share/gocode/src/github.com/gosexy/gettext ${GOPATH}/src/github.com/gosexy/
+
+	## gorilla/websocket
+#	mkdir -p ${GOPATH}/src/github.com/gorilla/
+#	ln -s /usr/share/gocode/src/github.com/gorilla/websocket ${GOPATH}/src/github.com/gorilla/
+
+	## olekukonko/tablewriter
+	mkdir -p ${GOPATH}/src/github.com/olekukonko/
+	ln -s /usr/share/gocode/src/github.com/olekukonko/tablewriter ${GOPATH}/src/github.com/olekukonko/
+
+	## x/crypto
+	mkdir -p ${GOPATH}/src/golang.org/x
+	ln -s /usr/share/gocode/src/golang.org/x/crypto ${GOPATH}/src/golang.org/x/
+
+	## yaml.v2
+	mkdir -p ${GOPATH}/src/gopkg.in/
+	ln -s /usr/share/gocode/src/gopkg.in/yaml.v2 ${GOPATH}/src/gopkg.in/
+
+	## dustinkirkland/golang-petname
+	mkdir -p ${GOPATH}/src/github.com/dustinkirkland/
+	ln -s /usr/share/gocode/src/github.com/dustinkirkland/golang-petname ${GOPATH}/src/github.com/dustinkirkland/golang-petname
+
+	## golang/protobuf
+	mkdir -p ${GOPATH}/src/github.com/golang/
+	ln -s /usr/share/gocode/src/github.com/golang/protobuf ${GOPATH}/src/github.com/golang/
+
+	## gorilla/context
+	mkdir -p ${GOPATH}/src/github.com/gorilla/
+	ln -s /usr/share/gocode/src/github.com/gorilla/context ${GOPATH}/src/github.com/gorilla/
+
+	## gorilla/mux
+	mkdir -p ${GOPATH}/src/github.com/gorilla/
+	ln -s /usr/share/gocode/src/github.com/gorilla/mux ${GOPATH}/src/github.com/gorilla/
+
+	## mattn/go-sqlite3
+	mkdir -p ${GOPATH}/src/github.com/mattn/
+	ln -s /usr/share/gocode/src/github.com/mattn/go-sqlite3 ${GOPATH}/src/github.com/mattn/
+
+	## pborman/uuid
+	mkdir -p ${GOPATH}/src/github.com/pborman/
+	ln -s /usr/share/gocode/src/github.com/pborman/uuid ${GOPATH}/src/github.com/pborman/
+
+	## coreos/go-systemd
+	mkdir -p ${GOPATH}/src/github.com/coreos/
+	ln -s /usr/share/gocode/src/github.com/coreos/go-systemd ${GOPATH}/src/github.com/coreos/
+
+	## syndtr/gocapability
+	mkdir -p ${GOPATH}/src/github.com/syndtr/
+	ln -s /usr/share/gocode/src/github.com/syndtr/gocapability ${GOPATH}/src/github.com/syndtr/
+
+	## tomb.v2
+	mkdir -p ${GOPATH}/src/gopkg.in/
+	ln -s /usr/share/gocode/src/gopkg.in/tomb.v2 ${GOPATH}/src/gopkg.in/
+
+	# Alternative packages
+	## stgraber/go-systemd
+	mkdir -p ${GOPATH}/src/github.com/stgraber/
+	ln -s ${GOPATH}/src/github.com/coreos/go-systemd ${GOPATH}/src/github.com/stgraber/lxd-go-systemd
+
+	# Packages that aren't in the archive
+	## inconshreveable/log15.v2
+	mkdir -p ${GOPATH}/src/gopkg.in/inconshreveable/
+	ln -s $(realpath dist/src/gopkg.in/inconshreveable/log15.v2) ${GOPATH}/src/gopkg.in/inconshreveable/log15.v2
+
+	## mattn/go-colorable
+	mkdir -p ${GOPATH}/src/github.com/mattn/
+	ln -s $(realpath dist/src/github.com/mattn/go-colorable) ${GOPATH}/src/github.com/mattn/
+
+	## flosch/pongo2.v3
+	mkdir -p ${GOPATH}/src/gopkg.in/flosch/
+	ln -s $(realpath dist/src/gopkg.in/flosch/pongo2.v3) ${GOPATH}/src/gopkg.in/flosch/
+
+	## lxc/go-lxc.v2
+	mkdir -p ${GOPATH}/src/gopkg.in/lxc/
+	ln -s $(realpath dist/src/gopkg.in/lxc/go-lxc.v2) ${GOPATH}/src/gopkg.in/lxc/
+
+	# Packages that aren't in main yet
+	## gosexy/gettext-go
+	mkdir -p ${GOPATH}/src/github.com/gosexy/
+	ln -s $(realpath dist/src/github.com/gosexy/gettext) ${GOPATH}/src/github.com/gosexy/
+
+	## gorilla/websocket
+	mkdir -p ${GOPATH}/src/github.com/gorilla/
+	ln -s $(realpath dist/src/github.com/gorilla/websocket) ${GOPATH}/src/github.com/gorilla/
+endif
 
 	go install -v github.com/lxc/lxd/lxc
 	go install -v github.com/lxc/lxd/lxd
@@ -35,6 +133,12 @@
 	help2man $(PKGDIR)/usr/bin/lxd -n "The container hypervisor - daemon" --no-info > $(PKGDIR)/usr/share/man/man1/lxd.1
 	help2man scripts/lxd-images -n "The container hypervisor - image importer" --version-string=$(VERSION) --no-info > $(PKGDIR)/usr/share/man/man1/lxd-images.1
 
+	# Prepare dev package
+	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
+	mkdir -p $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
+	cp -RL ${GOPATH}/src/github.com/lxc/lxd $(PKGDIR)/usr/share/gocode/src/github.com/lxc/
+	rm -Rf $(PKGDIR)/usr/share/gocode/src/github.com/lxc/lxd/dist
+
 	# Trigger normal dh_install
 	dh_install
